<template>
  <q-card class="itinerary-workbench c-col min-w-600px">
    <q-card-section class="header bg-primary text-white">
      <div class="text-24px">
        {{ headText }}
      </div>
    </q-card-section>
    <div class="c-col h-full">
      <div class="table-header p-5px row flex-center">
        <div class="px-5px opacity-0">
          1
        </div>
        <div class="col text-center">
          工作
        </div>
        <div class="col text-center">
          班別
        </div>
        <div class="col text-center">
          資格
        </div>
        <div class="px-5px">
          <q-icon
            name="settings"
            size="18px"
            color="grey-5"
          />
          <q-menu>
            <q-list
              dense
              style="min-width: 100px"
            >
              <q-item
                v-close-popup
                clickable
                @click="clearVacancies"
              >
                <q-item-section>全部刪除</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </div>
      </div>
      <div class="c-col h-full p-5px">
        <q-scroll-area class="h-full">
          <div
            v-for="(vacancy, i) in vacancies"
            :key="i"
            class="row py-5px flex-center"
          >
            <div class="px-5px">
              {{ i + 1 }}
            </div>
            <div class="col px-5px text-center">
              <q-select
                v-model="vacancy.job"
                :options="jobs"
                option-label="name"
                dense
                filled
              />
            </div>
            <div class="col px-5px text-center">
              <q-select
                v-model="vacancy.jobType"
                :options="jobTypes"
                option-label="name"
                dense
                filled
              />
            </div>
            <div class="col px-5px text-center">
              <q-select
                v-model="vacancy.requiredQualifications"
                :options="qualifications"
                multiple
                dense
                filled
                option-label="name"
                emit-value
              >
                <template #selected-item="scope">
                  <q-chip
                    dense
                    square
                    color="primary"
                    text-color="white"
                  >
                    {{ scope.opt.name }}
                  </q-chip>
                </template>
              </q-select>
            </div>
            <div class="px-5px">
              <q-icon
                name="settings"
                size="18px"
                color="grey-5"
              />
              <q-menu>
                <q-list
                  dense
                  style="min-width: 100px"
                >
                  <q-item
                    v-close-popup
                    clickable
                    @click="removeVacancy(i)"
                  >
                    <q-item-section>刪除</q-item-section>
                  </q-item>
                  <q-item
                    v-close-popup
                    clickable
                    @click="duplicateVacancy(i)"
                  >
                    <q-item-section>複製</q-item-section>
                  </q-item>
                </q-list>
              </q-menu>
            </div>
            <q-menu
              touch-position
              context-menu
            >
              <q-list
                dense
                style="min-width: 100px"
              >
                <q-item
                  v-close-popup
                  clickable
                  @click="removeVacancy(i)"
                >
                  <q-item-section>刪除</q-item-section>
                </q-item>
                <q-item
                  v-close-popup
                  clickable
                  @click="duplicateVacancy(i)"
                >
                  <q-item-section>複製</q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </div>
        </q-scroll-area>
        <q-btn
          :color="addVacancyBtnColor"
          unelevated
          @click="addVacancy"
        >
          增加職缺
        </q-btn>
      </div>
    </div>
  </q-card>
</template>

<script lang='ts' setup>
import { computed, defineComponent, PropType, ref, watch } from 'vue';
import { cloneDeep, isEqual } from 'lodash-es';
import { Vacancy } from '../../types/main.type';

import { useQuasar } from 'quasar';
import { useMainStore } from '../../store/main.store';

interface Props {
  selectedDates?: string[];
  vacancies?: Vacancy[];
}
const props = withDefaults(defineProps<Props>(), {
  selectedDates: () => [],
  vacancies: () => [],
});

const emit = defineEmits<{
  (e: 'update:vacancies', value: Vacancy[]): void;
}>();

const $q = useQuasar();
const store = useMainStore();

const jobs = computed(() => store.jobs);
const jobTypes = computed(() => store.jobTypes);
const dayItineraries = computed(() => store.dayItineraries);

// 職缺
const vacancies = ref<Vacancy[]>([]);
function addVacancy() {
  if (!props.selectedDates || props.selectedDates.length === 0) {
    $q.notify({
      type: 'negative',
      message: '請選擇日期',
    });
    return;
  }

  const job = jobs.value.length === 1 ? jobs.value[0] : null;
  const jobType = jobTypes.value.length === 1 ? jobTypes.value[0] : null;

  vacancies.value.push({
    job,
    jobType,
    executor: null,
    requiredQualifications: [],
    remark: '',
  });
}
function removeVacancy(i: number) {
  vacancies.value.splice(i, 1);
}
function duplicateVacancy(i: number) {
  vacancies.value.splice(i, 0, cloneDeep(vacancies.value[i]));
}
function clearVacancies() {
  vacancies.value = [];
}
function getVacancies(dates: string[]) {
  if (dates.length === 0) {
    return [];
  }

  // console.log(`[ getVacancies ] dates : `, dates);

  const itineraries = dates.map((date) => {
    return dayItineraries.value.find((item) => item.date === date);
  });

  if (itineraries.length === 1) {
    return itineraries[0]?.vacancies ?? [];
  }

  // console.log(`itineraries : `, itineraries);

  const allEqual = itineraries.every((itinerary) =>
    isEqual(itinerary?.vacancies, itineraries[0]?.vacancies)
  );

  if (allEqual) {
    return cloneDeep(itineraries[0]?.vacancies ?? []);
  }

  return [];
}

watch(
  vacancies,
  (val) => {
    emit('update:vacancies', val);
  },
  { deep: true }
);

// 選擇日期
watch(
  () => props.selectedDates,
  (dates) => {
    if (!dates || dates.length === 0) {
      clearVacancies();
      return;
    }

    vacancies.value = getVacancies(dates);
  },
  { immediate: true }
);

const headText = computed(() => {
  if (!props.selectedDates || props.selectedDates.length === 0) {
    return '請選擇日期';
  }

  if (props.selectedDates.length === 1) {
    return props.selectedDates[0];
  }

  return `選擇 ${props.selectedDates.length} 日`;
});

const addVacancyBtnColor = computed(() => {
  if (!props.selectedDates) {
    return 'grey';
  }

  if (props.selectedDates.length === 0) {
    return 'grey';
  }

  return 'primary';
});


const qualifications = computed(() => store.qualifications);
</script>
